ENTITY cas_sel2 IS 
  GENERIC(gen                     : STRING := "eta");
  PORT   (i0, i1, b0, b1          : IN  BIT; 
          c0, c1, c2, c3, sig_chr : IN  CHARACTER;
          t0, t1                  : IN INTEGER;
          o0, o1, o2, o3, o4, o5  : OUT BIT);
END cas_sel2;

ARCHITECTURE com_erros OF cas_sel2 IS
  SIGNAL   sel_stg : STRING(1 TO 3);
BEGIN
--WITH b1 & b0 SELECT      -- Erro: operacao pre-definida que nao retorna tipo discreto
--  o0 <= i0 WHEN "00",  
--        i1 WHEN OTHERS;       
                            
--WITH c2 & c1 & c0 SELECT -- Erro: operacao pre-definida que nao retorna tipo discreto
--  o1 <= i0 WHEN "abc",   
--        i1 WHEN OTHERS;
                           
  WITH b1 AND b0 SELECT    -- Correto: expressao pre-definida que retorna tipo discreto 
    o2 <= i0 WHEN '0',     -- Bit AND Bit = tipo Bit
          i1 WHEN '1';
              
--sel_stg <= c2 & c1 & c0;         
--WITH sel_stg SELECT       
--  o3 <= i0 WHEN gen,     -- Erro: valor definido por generico
--        i1 WHEN OTHERS; 

--WITH c3 SELECT           
--  o4 <= i0 WHEN sig_chr, -- Erro: valor definido por sinal
--        i1 WHEN OTHERS; 

  WITH t1 + t0 SELECT      -- Correto: expressao pre-definida que retorna tipo discreto 
    o5 <= i0 WHEN 7,       -- Integer + Integer = tipo Integer
          i1 WHEN OTHERS;             
END com_erros;